// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from marti_introspection_msgs:msg/NodeInfo.idl
// generated code does not contain a copyright notice

#ifndef MARTI_INTROSPECTION_MSGS__MSG__DETAIL__NODE_INFO__TRAITS_HPP_
#define MARTI_INTROSPECTION_MSGS__MSG__DETAIL__NODE_INFO__TRAITS_HPP_

#include "marti_introspection_msgs/msg/detail/node_info__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'topics'
#include "marti_introspection_msgs/msg/detail/topic_info__traits.hpp"
// Member 'parameters'
#include "marti_introspection_msgs/msg/detail/param_info__traits.hpp"
// Member 'services'
#include "marti_introspection_msgs/msg/detail/service_info__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const marti_introspection_msgs::msg::NodeInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: location
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "location: ";
    value_to_yaml(msg.location, out);
    out << "\n";
  }

  // member: nodelet_manager
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "nodelet_manager: ";
    value_to_yaml(msg.nodelet_manager, out);
    out << "\n";
  }

  // member: description
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "description: ";
    value_to_yaml(msg.description, out);
    out << "\n";
  }

  // member: topics
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.topics.size() == 0) {
      out << "topics: []\n";
    } else {
      out << "topics:\n";
      for (auto item : msg.topics) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: parameters
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.parameters.size() == 0) {
      out << "parameters: []\n";
    } else {
      out << "parameters:\n";
      for (auto item : msg.parameters) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: services
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.services.size() == 0) {
      out << "services: []\n";
    } else {
      out << "services:\n";
      for (auto item : msg.services) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const marti_introspection_msgs::msg::NodeInfo & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<marti_introspection_msgs::msg::NodeInfo>()
{
  return "marti_introspection_msgs::msg::NodeInfo";
}

template<>
inline const char * name<marti_introspection_msgs::msg::NodeInfo>()
{
  return "marti_introspection_msgs/msg/NodeInfo";
}

template<>
struct has_fixed_size<marti_introspection_msgs::msg::NodeInfo>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<marti_introspection_msgs::msg::NodeInfo>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<marti_introspection_msgs::msg::NodeInfo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MARTI_INTROSPECTION_MSGS__MSG__DETAIL__NODE_INFO__TRAITS_HPP_
